<?php
namespace Schaffen\BankIntegration\Cnab\Conciliacao\Cnab240;

use Carbon\Carbon;
use Schaffen\BankIntegration\Contracts\Cnab\Conciliacao\Cnab240\Detalhe as DetalheContract;
use Schaffen\BankIntegration\MagicTrait;

class Detalhe implements DetalheContract
{
    use MagicTrait;

    
    /**
     * @var int
     */
    public $codigoLote;

    /**
     * @var string
     */
    public $tipoRegistro;

    /**
     * @var int
     */
    public $numeroRegistro;
 
    /**
     * @var string
     */
    public $segmento;

    /**
     * @var int
     */
    public $idLancamento;
    
    /**
     * @var string
     */
    public $tipoInscricao;

    /**
     * @var int
     */
    public $numeroInscricao;

    /**
     * @var string
     */
    public $agencia;

    /**
     * @var string
     */
    public $agenciaDv;

    /**
     * @var string
     */
    public $conta;

    /**
     * @var string
     */
    public $contaDV;

    /**
     * @var string
     */
    public $nomeEmpresa;

    /**
     * @var string
     */
    public $natureza;

    /**
     * @var string
     */
    public $dataLancamento;

    /**
     * @var string
     */
    public $valor;

    /**
     * @var string
     */
    public $tipoLancamento;

    /**
     * @var int
     */
    public $categoria;

    /**
     * @var string
     */
    public $categoriaDescricao;

    /**
     * @var string
     */
    public $historico;

    /**
     * @var string
     */
    public $numeroDocumento;

    /**
     * @var int
     */
    public $linha;

    /**
     * @var int
     */
    public $statusLinha;


    /**
     * @return int
     */
    public function getCodigoLote()
    {
        return $this->codigoLote;
    }

     /**
     * @param int $codigoLote
     *
     * @return $this
     */
    public function setCodigoLote($codigoLote){
        $this->codigoLote = $codigoLote;

        return $this;
    }

    /**
     * @return int
     */
    public function getLinha()
    {
        return $this->linha;
    }

     /**
     * @param int $linha
     *
     * @return $this
     */
    public function setLinha($linha){
        $this->linha = $linha;

        return $this;
    }

     /**
     * @return int
     */
    public function getStatusLinha()
    {
        return $this->statusLinha;
    }

     /**
     * @param int $statusLinha
     *
     * @return $this
     */
    public function setStatusLinha($statusLinha){
        $this->statusLinha = $statusLinha;

        return $this;
    }

    /**
     * @return string
     */
    public function getTipoRegistro()
    {
        return $this->tipoRegistro;
    }

    /**
     * @param string $tipoRegistro
     *
     * @return $this
     */
    public function setTipoRegistro($tipoRegistro){
        $this->tipoRegistro = $tipoRegistro;

        return $this;
    }

     /**
     *
     * @return int
     */
    public function getNumeroRegistro()
    {
        return $this->numeroRegistro;
    }

    /**
     * @param int $numeroRegistro
     *
     * @return $this
     */
    public function setNumeroRegistro($numeroRegistro){
        $this->numeroRegistro = $numeroRegistro;

        return $this;
    }

    /**
     * @return string
     */
    public function getSegmento()
    {
        return $this->segmento;
    }

    /**
     * @param string $segmento
     *
     * @return $this
     */
    public function setSegmento($segmento){
        $this->segmento = $segmento;

        return $this;
    }

    /**
     * @return int
     */
    public function getIdLancamento()
    {
        return $this->idLancamento;
    }

    /**
     * @param int $idLancamento
     *
     * @return $this
     */
    public function setIdLancamento($idLancamento){
        $this->idLancamento = $idLancamento;

        return $this;
    }

    /**
     * @return string
     */
    public function getTipoInscricao()
    {
        return $this->tipoInscricao;
    }

    /**
     * @param string $tipoInscricao
     *
     * @return $this
     */
    public function setTipoInscricao($tipoInscricao){
        $this->tipoInscricao = $tipoInscricao;

        return $this;
    }

    /**
     * @return int
     */
    public function getNumeroInscricao()
    {
        return $this->numeroInscricao;
    }

    /**
     * @param int $numeroInscricao
     *
     * @return $this
     */
    public function setNumeroInscricao($numeroInscricao){
        $this->numeroInscricao = $numeroInscricao;

        return $this;
    }

    /**
     * @return string
     */
    public function getAgencia()
    {
        return $this->agencia;
    }

    /**
     * @param string $agencia
     *
     * @return $this
     */
    public function setAgencia($agencia){
        $this->agencia = $agencia;

        return $this;
    }

     /**
     * @return string
     */
    public function getAgenciaDv()
    {
        return $this->agenciaDv;
    }

    /**
     * @param string $agenciaDv
     *
     * @return $this
     */
    public function setAgenciaDv($agenciaDv)
    {
        $this->agenciaDv = $agenciaDv;

        return $this;
    }

    /**
     * @return string
     */
    public function getConta()
    {
        return $this->conta;
    }

    /**
     * @param string $conta
     *
     * @return $this
     */
    public function setConta($conta){
        $this->conta = $conta;

        return $this;
    }

    /**
     * @return string
     */
    public function getContaDv()
    {
        return $this->contaDV;
    }

    /**
     * @param string $contaDV
     *
     * @return $this
     */
    public function setContaDv($contaDV){
        $this->contaDV = $contaDV;

        return $this;
    }

    /**
     * @return string
     */
    public function getNomeEmpresa()
    {
        return $this->nomeEmpresa;
    }

    /**
     * @param string $nomeEmpresa
     *
     * @return $this
     */
    public function setNomeEmpresa($nomeEmpresa){
        $this->nomeEmpresa = $nomeEmpresa;

        return $this;
    }

    /**
     * @return string
     */
    public function getNatureza()
    {
        return $this->natureza;
    }

    /**
     * @param string $natureza
     *
     * @return $this
     */
    public function setNatureza($natureza){
        $this->natureza = $natureza;

        return $this;
    }

    // /**
    //  * @param string $format
    //  *
    //  * @return Carbon|null|string
    //  */
    // public function getDataLancamento($format = 'd/m/Y')
    // {
    //     return $this->dataVencimento instanceof Carbon
    //         ? $format === false ? $this->dataLancamento : $this->dataLancamento->format($format)
    //         : null;
    // }

    // /**
    //  * @param $dataLancamento
    //  *
    //  * @param string $format
    //  *
    //  * @return $this
    //  */
    // public function setDataLancamento($dataLancamento, $format = 'dmY')
    // {
    //     $this->dataLancamento = trim($dataLancamento, '0 ') ? Carbon::createFromFormat($format, $dataLancamento) : null;

    //     return $this;
    // }

    /**
     * @param string 
     */
    public function getDataLancamento()
    {
        return $this->dataLancamento;
    }

    /**
     * @param $dataLancamento
     *
     * @return $this
     */
    public function setDataLancamento($dataLancamento)
    {
        $this->dataLancamento = date_format(date_create_from_format('dmY', $dataLancamento), 'd/m/Y');;

        return $this;
    }



    /**
     * @return string
     */
    public function getValor()
    {
        return $this->valor;
    }

    /**
     * @param string $valor
     *
     * @return $this
     */
    public function setValor($valor)
    {
        $this->valor = $valor;

        return $this;
    }

    /**
     * @return string
     */
    public function getTipoLancamento()
    {
        return $this->tipoLancamento;
    }

   /**
     * @param string $tipoLancamento
     *
     * @return $this
     */
    public function setTipoLancamento($tipoLancamento)
    {
        $this->tipoLancamento = $tipoLancamento;

        return $this;
    }
    

    /**
     * @return int
     */
    public function getCategoria()
    {
        return $this->categoria;
    }

    /**
     * @param int $categoria
     *
     * @return $this
     */
    public function setCategoria($categoria)
    {
        $this->categoria = $categoria;

        return $this;
    }


    /**
     * @return string
     */
    public function getCategoriaDescricao()
    {
        return $this->categoriaDescricao;
    }

    /**
     * @param string $categoriaDescricao
     *
     * @return $this
     */
    public function setCategoriaDescricao($categoriaDescricao)
    {
        $this->categoriaDescricao = $categoriaDescricao;

        return $this;
    }

    /**
     * @return string
     */
    public function getHistorico()
    {
        return $this->historico;
    }

    /**
     * @param string $historico
     *
     * @return $this
     */
    public function setHistorico($historico)
    {
        $this->historico = $historico;

        return $this;
    }

    /**
     * @return string
     */
    public function getNumeroDocumento()
    {
        return $this->numeroDocumento;
    }

    /**
     * @param string $numeroDocumento
     *
     * @return $this
     */
    public function setNumeroDocumento($numeroDocumento)
    {
        $this->numeroDocumento = $numeroDocumento;

        return $this;
    }

}
